/*
 *  DVDSubEdit and this code is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  DVDSubEdit and this code are distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
*/

#include "stdafx.h"
#include "DVDSubEdit.h"
#include "MiscDialogs.h"
#include "SubPic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CApplyToAllDlg dialog


CApplyToAllDlg::CApplyToAllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CApplyToAllDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CApplyToAllDlg)
	m_ApplyVMove = FALSE;
	m_ApplyHMove = FALSE;
	m_ApplyStart = FALSE;
	m_ApplyTransp = FALSE;
	m_ApplyBorders = FALSE;
	m_ApplyDuration = FALSE;
	m_ApplyColor = FALSE;
	m_MinMax = 0;
	m_Duration = _T("");
	m_ApplyCrop = FALSE;
	m_ApplyFade = FALSE;
	m_ApplyHide = FALSE;
	//}}AFX_DATA_INIT
}


void CApplyToAllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CApplyToAllDlg)
	DDX_Check(pDX, IDC_APPLY_MOVE, m_ApplyVMove);
	DDX_Check(pDX, IDC_APPLY_MOVEH, m_ApplyHMove);
	DDX_Check(pDX, IDC_APPLY_START, m_ApplyStart);
	DDX_Check(pDX, IDC_APPLY_TRANSP, m_ApplyTransp);
	DDX_Check(pDX, IDC_APPLY_BORDER, m_ApplyBorders);
	DDX_Check(pDX, IDC_APPLY_DURATION, m_ApplyDuration);
	DDX_Check(pDX, IDC_APPLY_COLOR, m_ApplyColor);
	DDX_CBIndex(pDX, IDC_DURMINMAX, m_MinMax);
	DDX_Text(pDX, IDC_DURATION, m_Duration);
	DDX_Check(pDX, IDC_APPLY_CROP, m_ApplyCrop);
	DDX_Check(pDX, IDC_APPLY_FADE, m_ApplyFade);
	DDX_Check(pDX, IDC_APPLY_HIDE, m_ApplyHide);
	//}}AFX_DATA_MAP
}

void CApplyToAllDlg::ResetAllCheck()
{
	m_ApplyVMove = m_ApplyHMove = m_ApplyStart = m_ApplyTransp = m_ApplyBorders = m_ApplyDuration = 
		m_ApplyColor = m_ApplyCrop = false;
}

bool CApplyToAllDlg::AnyChecked()
{
	return 	m_ApplyVMove || m_ApplyHMove || m_ApplyStart || m_ApplyTransp || m_ApplyBorders || 
		m_ApplyDuration || m_ApplyColor || m_ApplyCrop;
}



BEGIN_MESSAGE_MAP(CApplyToAllDlg, CDialog)
	//{{AFX_MSG_MAP(CApplyToAllDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApplyToAllDlg message handlers


CMoveDlg::CMoveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMoveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMoveDlg)
	m_ChangeTimingBy = 0.0f;
	//}}AFX_DATA_INIT
	m_SliderRangeS = 10;
}


void CMoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMoveDlg)
	DDX_Control(pDX, IDC_MOVESLIDER, m_MoveSlider);
	DDX_Control(pDX, IDC_ABSOLUTE, m_MoveSelect);
	DDX_Text(pDX, IDC_MOVEAMOUNT, m_ChangeTimingBy);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMoveDlg, CDialog)
	//{{AFX_MSG_MAP(CMoveDlg)
	ON_CBN_SELCHANGE(IDC_ABSOLUTE, OnSelchangeAbsolute)
	ON_WM_HSCROLL()
	ON_EN_KILLFOCUS(IDC_MOVEAMOUNT, OnKillfocusMoveamount)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_DEFBUT, OnKillfocusMoveamount)
END_MESSAGE_MAP()

#define SLIDER_R 100		// ms per slider tic.
BOOL CMoveDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_MoveSelect.SetCurSel(0);
	m_CurSel = 0;
	m_MoveSelect.EnableWindow(!m_RetimeAll);
	SetWindowText(m_RetimeAll?"Change timing for all selected subpics":
		"Change timing for the current subpic");
	((CEdit*)GetDlgItem(IDC_MOVEAMOUNT))->SetSel(0,-1);
//	::SetFocus(GetDlgItem(IDC_MOVEAMOUNT)->m_hWnd);
	m_MoveSlider.SetRange(-(int)m_SliderRangeS*1000/SLIDER_R,(int)m_SliderRangeS*1000/SLIDER_R,TRUE);
	m_MoveSlider.SetPos(0);
	m_ThisPTS = m_Engine->m_SelectedSubPic->m_PTS;
	long ThisNavPack = m_Engine->m_SelectedSubPic->m_NavPackLBA;
	m_ThisVOBU = 0;
	// Now find which VOBU this corresponds to...
	int i;
	for(i=0;i<m_Engine->m_VobuInfo.size();i++)
	{
		if(m_Engine->m_VobuInfo[i].m_NavPackLBA == ThisNavPack) 
		{
			m_ThisVOBU = i;
			break;
		}
	}

	int NewPos = (int)(m_ChangeTimingBy * 1000 / SLIDER_R);
	m_MoveSlider.SetPos(NewPos);
	// This will ensure everything happens as if we moved the slider.
	ShowFrameForThisOffset(m_ChangeTimingBy);
		
	return TRUE; 
}

void CMoveDlg::OnOK() 
{
	m_CurSel = m_MoveSelect.GetCurSel();
	CDialog::OnOK();
}

void CMoveDlg::OnSelchangeAbsolute() 
{
	::SetFocus(GetDlgItem(IDC_MOVEAMOUNT)->m_hWnd);
	m_MoveSlider.ShowWindow(m_MoveSelect.GetCurSel() == 0 ? SW_SHOW : SW_HIDE);
}


void CMoveDlg::OnKillfocusMoveamount() 
{
	// Retrieve value.
	UpdateData(TRUE);
	int NewPos = (int)(m_ChangeTimingBy * 1000 / SLIDER_R);
	m_MoveSlider.SetPos(NewPos);
	// This will ensure everything happens as if we moved the slider.
	ShowFrameForThisOffset(m_ChangeTimingBy);
}

void CMoveDlg::ShowFrameForThisOffset(float OffsetSecs)
{
	int i;
	// Now I have to find the LBA of the I-frame!
	if(OffsetSecs < 0)
	{
		for(i=m_ThisVOBU;i>=0;i--)
		{
			if(m_Engine->m_VobuInfo[i].m_PTSFirstFrame < m_ThisPTS + m_Engine->SecsToPTS(OffsetSecs))
				break;
		}
		m_Engine->m_Preview->GoToSector(m_Engine->m_VobuInfo[i].m_NavPackLBA);
	}
	else
	{
		for(i=m_ThisVOBU;i<m_Engine->m_VobuInfo.size()-1;i++)
		{
			if(m_Engine->m_VobuInfo[i+1].m_PTSFirstFrame > m_ThisPTS + m_Engine->SecsToPTS(OffsetSecs))
				break;
		}
		m_Engine->m_Preview->GoToSector(m_Engine->m_VobuInfo[i].m_NavPackLBA);
	}
}


void CMoveDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	char Temp[128];
	switch(pScrollBar->GetDlgCtrlID())
	{
		case IDC_MOVESLIDER : 
			if(nSBCode == SB_ENDSCROLL) break;
			float Value = (float)m_MoveSlider.GetPos() * SLIDER_R / 1000;
			sprintf(Temp,"%.3f",Value);
			SetDlgItemText(IDC_MOVEAMOUNT,Temp);
			ShowFrameForThisOffset(Value);
			break;
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

//______________________________________
CPickColorDlg::CPickColorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPickColorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPickColorDlg)
	//}}AFX_DATA_INIT
	m_WindowTitle = 0;
	m_SelectedCol = m_InitSelectedCol = -1;
	m_WhichPixel = -1;
	m_MyRect.top = m_MyRect.bottom = 0;
}


void CPickColorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPickColorDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPickColorDlg, CDialog)
	//{{AFX_MSG_MAP(CPickColorDlg)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_COLB, IDC_COLB16, OnColClick )
END_MESSAGE_MAP()


BOOL CPickColorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	if(m_MyRect.Height() != 0)
	{
		MoveWindow(&m_MyRect);
	}
	if(m_WindowTitle) SetWindowText(m_WindowTitle);
	
	if(m_Engine->m_SelectedSubPic != 0 && m_Engine->m_SelectedSubPic->m_CLUT != 0)
	{
		int i;
		for(i=0;i<m_Engine->m_CLUTV.size();i++)
		{
			if(m_Engine->m_CLUTV[i]->m_CLUT[0] == m_Engine->m_SelectedSubPic->m_CLUT)
				break;
		}
		// It's possible we won't find that CLUT if the IFO was loaded separately.
		if(i < m_Engine->m_CLUTV.size())
		{
			char Temp[1024];
			if(m_Engine->m_CLUTV[i]->m_LU[0] > 0)
				sprintf(Temp,"CLUT in use is defined in\r\nLU %d / PGC %d\r\nShift-Click to modify CLUT",m_Engine->m_CLUTV[i]->m_LU[0],
					m_Engine->m_CLUTV[i]->m_PGC[0]);
			else
				sprintf(Temp,"CLUT in use is defined in\r\nPGC %d\r\nShift-Click to modify CLUT",m_Engine->m_CLUTV[i]->m_PGC[0]);
			SetDlgItemText(IDC_INFO,Temp);
		}
	}
	m_ClutMemorized = false;

	m_InitSelectedCol = m_SelectedCol;
	return TRUE;
}

void CPickColorDlg::OnPaint() 
{
	if(m_Engine->m_SelectedSubPic == 0 || m_Engine->m_SelectedSubPic->m_CLUT == 0)
		return;
	PAINTSTRUCT Ps;
	BeginPaint(&Ps);
	int i;
	unsigned char* CLUT = m_Engine->m_SelectedSubPic->m_CLUT;
	HDC TheDC = Ps.hdc;
	CRect Temp;
	uint ID;
	HBRUSH Black = (HBRUSH)CreateSolidBrush(RGB(0,0,0));
	for(i=0;i<16;i++)
	{
		ID = IDC_COLB+i;
		GetDlgItem(ID)->GetWindowRect(&Temp);
		ScreenToClient(&Temp);
		HBRUSH Color = (HBRUSH)CreateSolidBrush(RGB(CLUT[3*i],CLUT[3*i+1],CLUT[3*i+2]));
		FillRect(TheDC,Temp,Color);
		FrameRect(TheDC,&Temp,Black);
		DeleteObject(Color);
	}
	if(m_SelectedCol >= 0)
	{
		GetDlgItem(IDC_SELECTEDCOL)->GetWindowRect(&Temp);
		ScreenToClient(&Temp);
		HBRUSH Color = (HBRUSH)CreateSolidBrush(RGB(CLUT[3*m_SelectedCol],CLUT[3*m_SelectedCol+1],
			CLUT[3*m_SelectedCol+2]));
		HPEN Pen = CreatePen(PS_DASH,2,RGB(0,0,0));
		SelectObject(TheDC,Pen);
		SelectObject(TheDC,Color);
		Rectangle(TheDC,Temp.left,Temp.top,Temp.right,Temp.bottom);

		GetDlgItem(IDC_COLB+m_SelectedCol)->GetWindowRect(&Temp);
		ScreenToClient(&Temp);
		Rectangle(TheDC,Temp.left,Temp.top,Temp.right,Temp.bottom);
		ScreenToClient(&Temp);
		DeleteObject(Pen);
		DeleteObject(Color);
	}
	DeleteObject(Black);
	EndPaint(&Ps);
}

void CPickColorDlg::OnColClick(UINT nID) 
{
	m_SelectedCol = nID-IDC_COLB;
	InvalidateRect(0,true);
	if(GetAsyncKeyState(VK_SHIFT) & 0x8000)
	{
		// Here I'm popping a color selection dialog so you can alter the CLUT.
		static CColorDialog TheColDialog(RGB(40,40,40)); 
		if(TheColDialog.DoModal() == IDOK)
		{
			uchar* CLUT = m_Engine->m_SelectedSubPic->m_CLUT;
			if(m_ClutMemorized == false)
			{
				m_ClutMemorized = true;
				memcpy(m_OrigCLUT,CLUT,16*3);
			}
			COLORREF Chosen = TheColDialog.GetColor();
			CLUT[3*m_SelectedCol]=GetRValue(Chosen);
			CLUT[3*m_SelectedCol+1]=GetGValue(Chosen);
			CLUT[3*m_SelectedCol+2]=GetBValue(Chosen);
			InvalidateRect(0,true);
//			m_Engine->MarkCLUTModified(m_Engine->m_SelectedSubPic->m_VOBID,m_Engine->m_SelectedSubPic->m_CELLID);
		}
	}
	m_Engine->m_SelectedSubPic->m_ColorPtr[m_WhichPixel] = m_SelectedCol;
	m_Engine->ViewSPU(m_Engine->m_SPUSlider.GetPos());
}


void CPickColorDlg::OnCancel() 
{
	m_SelectedCol = m_InitSelectedCol;
	// Restore original color. 
	m_Engine->m_SelectedSubPic->m_ColorPtr[m_WhichPixel] = m_SelectedCol;
	m_Engine->ViewSPU(m_Engine->m_SPUSlider.GetPos());
	// Restore original CLUT if needed.
	uchar* CLUT = m_Engine->m_SelectedSubPic->m_CLUT;
	if(m_ClutMemorized)
		memcpy(CLUT,m_OrigCLUT,16*3);
	CDialog::OnCancel();
}

void CPickColorDlg::OnOK() 
{
	// Restore original color. It will be changed in the calling code.
	m_Engine->m_SelectedSubPic->m_ColorPtr[m_WhichPixel] = m_InitSelectedCol;
	// If needed, mark CLUT modified.
	uchar* CLUT = m_Engine->m_SelectedSubPic->m_CLUT;
	if(memcmp(CLUT,m_OrigCLUT,16*3) != 0)
		m_Engine->MarkCLUTModified(m_Engine->m_SelectedSubPic->m_VOBID,m_Engine->m_SelectedSubPic->m_CELLID);
	CDialog::OnOK();
}

void CPickColorDlg::OnDestroy() 
{
	GetWindowRect(&m_MyRect);
	CDialog::OnDestroy();
}


//______________________________________
CSetupDlg::CSetupDlg(BOOL Recenter, CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_Recenter = TRUE;
	m_AlignBottom = TRUE;
	m_BracketSquare = TRUE;
	m_BracketParen = TRUE;
	m_BracketNotes = FALSE;
	m_Italics = TRUE;
	m_RemoveColumns = FALSE;
	m_SpaceSelect = 0;
	m_CaseSensitive = FALSE;
	m_AskForIFO = FALSE;
	m_AlertClosedCaptions = FALSE;
	m_AutoDisplay = FALSE;
	m_RetimeSliderRange = 0.0f;
	m_CropBorderPixelsX = 0;
	m_CropBorderPixelsY = 0;
	m_BitmapEditTool = _T("");
	m_BitmapEditToolArgs = _T("");
	m_EditBitmapAs24 = FALSE;
	//}}AFX_DATA_INIT
	m_Recenter = Recenter;
	SetBrackets();
}


void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_CBIndex(pDX, IDC_FPS, m_FPS);
	DDX_Check(pDX, IDC_RECENTER, m_Recenter);
	DDX_Check(pDX, IDC_ALIGNEBOT, m_AlignBottom);
	DDX_Check(pDX, IDC_BRACK0, m_BracketSquare);
	DDX_Check(pDX, IDC_BRACK1, m_BracketParen);
	DDX_Check(pDX, IDC_BRACK2, m_BracketNotes);
	DDX_Check(pDX, IDC_ITALICS, m_Italics);
	DDX_Check(pDX, IDC_REMOVECOLUMNS, m_RemoveColumns);
	DDX_CBIndex(pDX, IDC_SPACESELECT, m_SpaceSelect);
	DDX_Check(pDX, IDC_CASESENS, m_CaseSensitive);
	DDX_Check(pDX, IDC_ASKFORIFO, m_AskForIFO);
	DDX_Check(pDX, IDC_ALERTCC, m_AlertClosedCaptions);
	DDX_Check(pDX, IDC_AUTODISPLAY, m_AutoDisplay);
	DDX_Text(pDX, IDC_RETIMESLIDERRANGE, m_RetimeSliderRange);
	DDX_Text(pDX, IDC_CROPBORDER, m_CropBorderPixelsX);
	DDX_Text(pDX, IDC_CROPBORDERY, m_CropBorderPixelsY);
	DDX_Text(pDX, IDC_BITMAPEDITTOOL, m_BitmapEditTool);
	DDX_Text(pDX, IDC_BITMAPEDITTOOLARGS, m_BitmapEditToolArgs);
	DDX_Check(pDX, IDC_EDITBITMAPAS24, m_EditBitmapAs24);
	//}}AFX_DATA_MAP

	SetBrackets();
	m_Engine->m_AlertIfCC = m_AlertClosedCaptions;
	m_Engine->m_MoveDialog->m_SliderRangeS = m_RetimeSliderRange;
	m_Engine->m_Preview->SetFrameDownSample(m_FPS);
	CSubPic::m_CropBackBorderX = m_CropBorderPixelsX;
	CSubPic::m_CropBackBorderY = m_CropBorderPixelsY;
}

BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BACKGDCOL, OnBackgdcol)
	ON_BN_CLICKED(IDC_SETPAH, OnSetBMPEditToolPath)
	//}}AFX_MSG_MAP
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
END_MESSAGE_MAP()


BOOL CSetupDlg::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	// Multiline tooltips: http://www.thecodeproject.com/miscctrl/tooltipex.asp
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
		switch(nID)
		{
		case IDC_FPS : pTTT->lpszText = "Frame per second for video playback. Adjust if audio stutters on a slow machine"; break; 
		case IDC_CASESENS : pTTT->lpszText = "Select case-sensitive searches on OCR output"; break; 
		case IDC_RECENTER : pTTT->lpszText = "After erasing part of a subtitle line, recenters it were it was before"; break; 
		case IDC_ALIGNEBOT : pTTT->lpszText = "When erasing a full line of text, moves lines above down to fill the gap"; break; 
		case IDC_BRACK0 : pTTT->lpszText = "Erases text between square brackets"; break; 
		case IDC_BRACK1 : pTTT->lpszText = "Erases text between parentheses"; break; 
		case IDC_BRACK2 : pTTT->lpszText = "Erases text between music notes (#)"; break; 
		case IDC_ITALICS : pTTT->lpszText = "Detects text in italics and straightens it before OCR"; break; 
		case IDC_REMOVECOLUMNS : pTTT->lpszText = "Erase single word followed by column, as in \"Man : What is that about\""; break; 
		case IDC_SPACESELECT : pTTT->lpszText = "Select Auto, large values if extra spaces occur in the OCR, or small values if words are glued together"; break; 
		case IDC_ASKFORIFO : pTTT->lpszText = "Always open \"Open IFO\" panel after loading .sup files"; break; 
		case IDC_ALERTCC : pTTT->lpszText = "Pop an alert message if Closed Captions are detected in the mpeg video stream"; break; 
		case IDC_AUTODISPLAY : pTTT->lpszText = "Automatically adjust 16:9 display mode as a function of subpic stream display mode(s)"; break; 
		case IDC_BACKGDCOL : pTTT->lpszText = "Click to select background color when no video is shown"; break; 
		case IDC_RETIMESLIDERRANGE : pTTT->lpszText = "Sets the range of the retiming slider"; break; 
		case IDC_CROPBORDER : pTTT->lpszText = "When cropping the background, how much wider than the text should the background be."; break; 
		case IDC_CROPBORDERY : pTTT->lpszText = "When cropping the background, how much taller than the text should the background be."; break; 
		case IDC_BITMAPEDITTOOL : pTTT->lpszText = "Path of bitmap editing tool to use when editing the subpic by hand."; break; 
		case IDC_EDITBITMAPAS24 : pTTT->lpszText = "Save bitmap as 24-bit or 4-bit bmp file while editing subpic by hand"; break; 
		case IDC_BITMAPEDITTOOLARGS : pTTT->lpszText = "Optional command line argument for bitmap editing tool"; break; 
		}
		pTTT->hinst = AfxGetResourceHandle();
		return(TRUE);
    }
    return(FALSE);
}

BOOL CSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_InitBackgroundColor = m_DefBackgroundColor;
	EnableToolTips(true);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

#define LOADCOLOR(Array,Col){*(Array)=GetRValue(Col);*(Array+1)=GetGValue(Col);*(Array+2)=GetBValue(Col);}
void CSetupDlg::OnCancel() 
{
	m_DefBackgroundColor = m_InitBackgroundColor;
	// Restore original color. 
	LOADCOLOR(CSubPic::m_BackColor,m_DefBackgroundColor);
	m_Engine->InvalidateRect(0,0);
	CDialog::OnCancel();
}

void CSetupDlg::SetBrackets()
{
	int i=0;
	strcpy(m_Brackets,"     ");
	if(m_BracketSquare) m_Brackets[i] = '[', m_Brackets[5-i] = ']', i++;
	if(m_BracketParen) m_Brackets[i] = '(', m_Brackets[5-i] = ')', i++;
	if(m_BracketNotes) m_Brackets[i] = '#', m_Brackets[5-i] = '#', i++;

	// Now copy the last pair of bracket characters to fill our array of 6.
	if(i==0) 
		m_Brackets[i] = '[', m_Brackets[5-i] = ']', i++;
	int j;
	for(j=i-1;i<3;i++)
	{
		m_Brackets[i] = m_Brackets[j];
		m_Brackets[5-i] = m_Brackets[5-j];
	}
}

void CSetupDlg::OnBackgdcol() 
{
	static CColorDialog TheColDialog(m_DefBackgroundColor); 
	if(TheColDialog.DoModal() == IDOK)
	{
		m_DefBackgroundColor = TheColDialog.GetColor();
		LOADCOLOR(CSubPic::m_BackColor,m_DefBackgroundColor);
		m_Engine->InvalidateRect(0,0);
		InvalidateRect(0,0);
	}
}

void CSetupDlg::OnPaint() 
{
	// This is needed so we colorize the background color tile.
	PAINTSTRUCT Ps;
	BeginPaint(&Ps);
	HDC TheDC = Ps.hdc;
	CRect Temp;
	HBRUSH Black = (HBRUSH)CreateSolidBrush(RGB(0,0,0));
	GetDlgItem(IDC_BACKGDCOL)->GetWindowRect(&Temp);
	ScreenToClient(&Temp);
	HBRUSH Color = (HBRUSH)CreateSolidBrush(m_DefBackgroundColor);
	FillRect(TheDC,Temp,Color);
	FrameRect(TheDC,&Temp,Black);
	DeleteObject(Color);
	DeleteObject(Black);
	EndPaint(&Ps);
}

void CSetupDlg::OnSetBMPEditToolPath() 
{
	CFileDialog FileDialog(TRUE, CString("*.exe"), "", NULL, 
		CString("bmp Files (*.exe)|*.exe||"));
	FileDialog.m_ofn.lpstrTitle = "Select bitmap (.BMP) editing tool";
	if(m_BitmapEditTool != "") FileDialog.m_ofn.lpstrInitialDir = m_BitmapEditTool;
	if (FileDialog.DoModal() == IDOK)
		SetDlgItemText(IDC_BITMAPEDITTOOL, FileDialog.GetPathName());
}

void CSetupDlg::OnOK() 
{
	UpdateData();
	if(m_BitmapEditTool != "" && !PathExists(m_BitmapEditTool))
	{
		ERROR1("The path you've indicated for the bitmap edit tool does not exist.\nLeave it empty or set it to an existing app");
		return;
	}
	CDialog::OnOK();
}

